package com.company.sample.view.customer;

import com.company.sample.entity.Customer;

import com.company.sample.view.main.MainView;

import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.ViewNavigators;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "customers", layout = MainView.class)
@ViewController("Customer.list")
@ViewDescriptor("customer-list-view.xml")
@LookupComponent("customersDataGrid")
@DialogMode(width = "64em")
public class CustomerListView extends StandardListView<Customer> {

    @Autowired
    private ViewNavigators viewNavigators;
    @ViewComponent
    private DataGrid<Customer> customersDataGrid;

    @Subscribe(id = "createBobBtn", subject = "clickListener")
    public void onCreateBobBtnClick(final ClickEvent<JmixButton> event) {
        viewNavigators.detailView(customersDataGrid)
                .newEntity()
                .withViewClass(CustomerDetailView.class)
                .withAfterNavigationHandler(afterViewNavigationEvent -> {
                    CustomerDetailView customerDetailView = afterViewNavigationEvent.getView();
                    customerDetailView.setCustomerFirstName("Bob");
                })
                .navigate();
    }
}